# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  


#!/bin/bash

 echo  "in ThirdParty-install-VTK.sh, source " $PWD/scripts/CreaTools-configure.sh
 if [ ! -f $PWD/scripts/CreaTools-configure.sh ]
 then 
   echo
   echo "..ERROR.."
   echo "==================================================="
   echo "REMEMBER !"
   echo ""
   echo "YOU NEED TO RUN 'Configure' (0) First !"
   echo "==================================================="
   echo
   echo
   exit 0
fi

source $PWD/scripts/CreaTools-configure.sh

   echo "------"
   echo $PWD/scripts/CreaTools-configure.sh
   echo --generationdir--
   echo $generationdir
   echo --docgeneration--
   echo $docgeneration
   echo --installPrefix--
   echo $installPrefix
   echo --installPrefixThird--
   echo $installPrefixThird
   echo --buildType--
   echo $buildType
   echo --gdcmVersion--
   echo $gdcmVersion
#   echo --sourcesFrom--
#   echo $sourcesFrom
#   echo --scriptDir--
#   echo $scriptDir
#   echo --start_point--
#   echo $start_point
   echo "------"


 

#EED 2017-03-24
  source $PWD/scripts/LocalFunctions.sh
  if [ `getDistrib` == "CentOS" ] && [ `getKernelVersion` < "2.6.34" ]
  then
	stdCompiler=c++98
#  else
#	stdCompiler=c++03
  fi


scriptDir=$PWD
sourcesDir=$generationdir/thirdparty_sources
binDir=$generationdir/thirdparty_bin

if [ ! -e $generationdir ]
then
   mkdir -p $generationdir
   chown -R $loginUserName  $generationdir
   chgrp -R $loginGroupName $generationdir

fi
if [ ! -e $sourcesDir ]
then
   mkdir -p $sourcesDir
   #was : (pb on MacOS?)
   #chown -R $loginUserName:$loginGroupName $sourcesDir
   chown -R $loginUserName  $sourcesDir
   chgrp -R $loginGroupName $sourcesDir
fi

if [ ! -e $binDir ]
then
   mkdir -p $binDir
   chown -R $loginUserName  $binDir
   chgrp -R $loginGroupName $binDir
fi

  echo "we remove old stuff"
  rm -rf $sourcesDir/VTK*
  rm -rf $sourcesDir/vtk*
  rm -rf $binDir/VTK*

  cd $sourcesDir

 echo "we download new stuff"
##   if [ $OperatingSystem = "MacOS" ]
##   then
##  
## # EED 2013-10-29
## #  curl -O http://www.creatis.insa-lyon.fr/software/public/creatools/crea_ThirdParty_Libraries/source/VTK-5.6.1.patchCreatis.tar.gz
## #  # MacOS, clever enough to understand it *has* to uncompress, doesn't understand tar -z :-(
## #  tar -xvf VTK-5.6.1.patchCreatis.tar.gz
## 
##   curl -O http://www.vtk.org/files/release/5.10/vtk-5.10.1.zip
##   unzip vtk-5.10.1.zip
##   cd VTK5.10.1/Rendering
##   curl -O http://www.creatis.insa-lyon.fr/software/public/creatools/crea_ThirdParty_Libraries/source/vtk-5.10.1.vtkXOpenGLRenderWindow.patch
##   patch < vtk-5.10.1.vtkXOpenGLRenderWindow.patch
##   # MacOS, clever enough to understand it *has* to uncompress, doesn't understand tar -z :-(
##  else
## 
## ## EED 2013-10-29
## ##  wget http://www.creatis.insa-lyon.fr/software/public/creatools/crea_ThirdParty_Libraries/source/VTK-5.6.1.patchCreatis.tar.gz
## ##  tar -xzvf VTK-5.6.1.patchCreatis.tar.gz
## 
## ## EED 2016-12-28
## ##  wget http://www.vtk.org/files/release/5.10/vtk-5.10.1.zip
## ##  echo unzip vtk-5.10.1.zip
## ##  pwd
## ##  unzip vtk-5.10.1.zip
## ##  cd VTK5.10.1/Rendering
## ####EED19mai2015  wget http://www.creatis.insa-lyon.fr/software/public/creatools/crea_ThirdParty_Libraries/source/vtk-5.10.1.vtkXOpenGLRenderWindow.patch
## ##  wget http://www.creatis.insa-lyon.fr/~davila/creatools_back_site/crea_ThirdParty_Libraries/source/vtk-5.10.1.vtkXOpenGLRenderWindow.patch
## ##  patch < vtk-5.10.1.vtkXOpenGLRenderWindow.patch
## ##  cd ../CMake
## ##  wget http://www.creatis.insa-lyon.fr/~davila/creatools_back_site/crea_ThirdParty_Libraries/source/vtk-5.10.1.vtkCompilerExtras.cmake-PATCH
## ##  patch < vtk-5.10.1.vtkCompilerExtras.cmake-PATCH 
## 
## ##	wget http://www.vtk.org/files/release/7.1/VTK-7.1.0.zip
## 	wget https://www.vtk.org/files/release/8.1/VTK-8.1.1.zip
## 	unzip VTK-8.1.1.zip
## 
##  fi

##  wget https://www.vtk.org/files/release/8.2/VTK-8.2.0.zip
##  unzip VTK-8.2.0.zip


cxxFlags='  '
if [ $TDx == "ON" ]
then
    cxxFlags=$cxxFlags'-F/Library/Frameworks -DVTK_USE_TDX '
#    libname=VTK-8.2.0-Patch-TDx
else
#    libname=VTK-8.2.0-Patch
	 libname=VTK-9.2.0.rc1
fi

wget http://www.creatis.insa-lyon.fr/~davila/creatools_back_site/crea_ThirdParty_Libraries/source/$libname-Patch-2022-08-04.zip
unzip $libname-Patch-2022-08-04.zip







#if [ $buildType = "Debug" ]
#then
#   debug="ON"
#else
#   debug="OFF"
#fi

### the following stupid test is used at debug time; Please don't remove!
###if [ true = false ]
##if [ true = true ]
##then
##  libname=VTK5.10.1
##  dirInstall=$binDir/$libname-Bin
####  export VTK_DIR=$installPrefixThird/lib/vtk-5.6/
##  export VTK_DIR=$installPrefixThird/lib/vtk-5.10/
##
##  mkdir -p $dirInstall
##  echo "we prepare directories dirInstall " $dirInstall  " VTK_DIR " $installPrefixThird/lib/vtk-5.10.1/
##  cd $dirInstall
##
### See EED why we have to do this
##  if [ $OperatingSystem = "MacOS" ]
##  then
##     cmake -D  CMAKE_CXX_COMPILER:FILE=/usr/bin/g++
##  fi
##  cmake -G"Unix Makefiles" -H$sourcesDir/$libname -B$dirInstall/
##  ##cmake -G"CodeBlocks - Unix Makefiles" -H$sourcesDir/$libname -B$dirInstall/
##  cmake -D CMAKE_BUILD_TYPE:STRING=$buildType -D CMAKE_INSTALL_PREFIX:PATH=$installPrefixThird CMakeCache.txt
##
##  if [ $OperatingSystem = "MacOS" ]
##  then
##    cmake -D BUILD_SHARE_LIBS:BOOL=ON -D VTK_USE_CARBON:BOOL=ON -D  VTK_USE_COCOA:BOOL=OFF CMakeCache.txt
##    cmake -D  VTK_USE_TCL:BOOL=OFF                                                         CMakeCache.txt
##    CMakeCache.txt
##  fi
##
##  cmake -D BUILD_EXAMPLES:BOOL=OFF -D BUILD_TESTING:BOOL=OFF -D BUILD_SHARED_LIBS:BOOL=ON -D VTK_USE_QT:BOOL=ON CMakeCache.txt
##  cmake -D CMAKE_CXX_FLAGS:STRING='-std=c++03' CMakeCache.txt
##
####EED 2016-12-22  make -j $corenumber
##  make -j $corenumber
##  make -j $corenumber install
##  cd ..
##fi


# the following stupid test is used at debug time; Please don't remove!
#if [ true = false ]
if [ true = true ]
then
##  libnameB=vtk-8.2
  libnameB=vtk-9.2
  dirInstall=$binDir/$libname-Bin
##  export VTK_DIR=$installPrefixThird/lib/vtk-5.6/
  export VTK_DIR=$installPrefixThird/lib/cmake/$libnameB/

  mkdir -p $dirInstall
  echo "we prepare directories dirInstall " $dirInstall  " VTK_DIR " $installPrefixThird/lib/$libnameB/
  cd $dirInstall

# See EED why we have to do this
#  if [ $OperatingSystem = "MacOS" ]
#  then
#     cmake -D  CMAKE_CXX_COMPILER:FILE=/usr/bin/g++
#  echo
#  fi

  cmake -G"Unix Makefiles" -H$sourcesDir/$libname -B$dirInstall/
  ##cmake -G"CodeBlocks - Unix Makefiles" -H$sourcesDir/$libname -B$dirInstall/
  
  cmake -D CMAKE_CXX_FLAGS:STRING="$cxxFlags"                                 CMakeCache.txt
  cmake -D CMAKE_BUILD_TYPE:STRING=$buildType -D CMAKE_INSTALL_PREFIX:PATH=$installPrefixThird CMakeCache.txt

  if [ $OperatingSystem = "MacOS" ]
  then
#    cmake -D BUILD_SHARE_LIBS:BOOL=ON -D VTK_USE_CARBON:BOOL=OFF -D  VTK_USE_COCOA:BOOL=ON CMakeCache.txt
#    cmake -D  VTK_USE_TCL:BOOL=OFF                                                         CMakeCache.txt
    CMakeCache.txt
   echo
  fi

 # cmake -D VTK_Group_Views:BOOL=ON -D VTK_Group_Qt:BOOL=OFF   CMakeCache.txt
 # cmake -D BUILD_EXAMPLES:BOOL=OFF -D BUILD_TESTING:BOOL=OFF -D BUILD_SHARED_LIBS:BOOL=ON CMakeCache.txt
  cmake -D CMAKE_INSTALL_LIBDIR:STRING="lib" CMakeCache.txt

  make -j $corenumber
  make -j $corenumber install
  cd ..

fi





